<?php
/**
 * Automatically created by MageSpecialist CodeMonkey
 * https://github.com/magespecialist/m2-MSP_CodeMonkey
 */

declare(strict_types=1);

namespace MSP\NotifierQueue\Model\ChannelExt\Command;

use Magento\Framework\Exception\CouldNotSaveException;

/**
 * Save ChannelExt data command (Service Provider Interface - SPI)
 *
 * Separate command interface to which Repository proxies initial Save call, could be considered as SPI - Interfaces
 * that you should extend and implement to customize current behaviour, but NOT expected to be used (called) in the code
 * of business logic directly
 *
 * @see \MSP\NotifierQueueApi\Api\ChannelExtRepositoryInterface
 * @api
 */
interface SaveInterface
{
    /**
     * Save ChannelExt data
     *
     * @param \MSP\NotifierQueueApi\Api\Data\ChannelExtInterface $source
     * @return int
     * @throws CouldNotSaveException
     */
    public function execute(\MSP\NotifierQueueApi\Api\Data\ChannelExtInterface $source): int;
}
